C
C     Last change:  LMT  25 Jul 96    9:48 am
C
      SUBROUTINE PLOTS(I1,I2,MODE)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL PLOTS. THIS IS DONE BY
C     USING THE INTERACTER COMMANDS FOR INITIALIZATION OF GRAPHICS MODE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER I1, I2, MODE
C
C     + + + ARGUMENT SPECFICATION + + +
C     I1, I2 - DUMMY VARIBLES FOR COMPATIBLITY MAY USE LATER
C     MODE - SELECTS VIDEO MODE 1- 640x480x8col 2-800x600x16col
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'interif.inc'
      INCLUDE 'intset.cmn'
C
C     + + + LOCAL VARIBLES + + +
      CHARACTER coltype*3, vers*80
      INTEGER nx, ny, ncolor, screen, iniunit
      REAL areaxleft, areaylower, areaxright, areayupper
      REAL unitxleft, unitylower
      LOGICAL fileopen, fileold
C
C     + + + EXTERNALS + + +
      INTEGER INFOERROR
      EXTERNAL PLTFILE, INTERRORLOG, ISCREENINIT, IGRINIT, IGRAREA, 
     &         IGRAREACLEAR, IGRCHARSET, IOUTMESSAGE, IGRCHARSPACING, 
     &         IGRUNITS, FACTOR, NEWPEN, INTPLOTINIT, INFOERROR
C
C     + + + DATA INITIALIZATIONS + + +
      LOGICAL first
      SAVE first
      DATA first/.TRUE./
C
C     + + + SCREEN AREA DATA + + +
      DATA areaxleft/0.0/, areaylower/0.0/
      DATA areaxright/1.0/, areayupper/1.0/
C
C     + + + GRAPHICS MODE DATA + + +
C     MODE SELECT THESE??? USE OTHER CALLS TO DETERMINE THESE???
      DATA coltype/'COL'/
      DATA unitxleft/0.0/, unitylower/0.0/
C
C     + + + END SPECIFICATIONS + + +
C
C---CALL INITIALIZATION PROGRAM FOR FIRST ITME THROUGH
      IF (first) THEN
        CALL PLTFILE
        first = .FALSE.
        vers = '@(#) libcalin - CalComp to Interactor library'
        vers = '@(#) libcalin - Contact: h2osoft@usgs.gov'
        vers = '@(#) libcalin - Version: 6.0x 1997/03/13'
        vers =
     & '$Id: calinter.f,v 6.0 1997/03/13 16:37:49 rsregan Exp rsregan $'
      ENDIF
C
C---OPEN ERROR LOG
      CALL INTERRORLOG
C
      DO 10 iniunit = 30, 100
        INQUIRE (iniunit,OPENED=fileopen)
        IF (.NOT.fileopen) THEN
          fileold = .FALSE.
          INQUIRE (FILE='plot.ini',EXIST=fileold)
          IF (fileold) THEN
            OPEN (iniunit,FILE='plot.ini',STATUS='OLD',ERR=40)
            READ (iniunit,'(L2,X,A12)',ERR=40) Symtype, Charset
            READ (iniunit,'(I2,2F5.2)',ERR=40) screen, Gridx, Gridy
            READ (iniunit,'(6I6)',ERR=40) Linetype
            GOTO 30
          ELSE
            WRITE (*,*) 'ERROR NO PLOT.INI FILE'
            WRITE (Errunit,*) 'ERROR NO PLOT.INI FILE'
          ENDIF
        ENDIF
   10 CONTINUE
C
C---SET SCREEN
   30 nx = 640
      ny = 480
      ncolor = 8
      IF (screen.EQ.2) THEN
        nx = 640
        ny = 480
        ncolor = 16
      ELSEIF (screen.EQ.3) THEN
        nx = 800
        ny = 600
        ncolor = 8
      ELSEIF (screen.EQ.4) THEN
        nx = 800
        ny = 600
        ncolor = 16
      ENDIF
C
      CALL ISCREENINIT(' ')
      CALL IGRINIT(coltype,nx,ny,ncolor)
      CALL IGRAREA(areaxleft,areaylower,areaxright,areayupper)
      CALL IGRAREACLEAR
      IF (Symtype) THEN
        CALL IGRCHARSPACING('F')
        CALL IGRCHARSET(Charset)
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      THEN
          CALL IOUTMESSAGE('Could not open/read character set. PLOTS')
          WRITE (Errunit,*) 'Could not open/read character set. PLOTS'
        ENDIF
        CALL IGRCHARSIZE(.25,.25)
C---symtype
      ENDIF
      CALL IGRUNITS(unitxleft,unitylower,Gridx,Gridy)
      CALL FACTOR(1.0)
      CALL INTPLOTINIT(iniunit)
      CALL NEWPEN(1)
      CLOSE (iniunit)
      RETURN
C
   40 WRITE (*,*) 'ERROR READING PLOT.INI FILE. '
      WRITE (Errunit,*) 'ERROR READING PLOT.INI FILE. '
      STOP
      END
C
C
C
      SUBROUTINE NEWPEN(INT)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL NEWPEN USING INTERACTER.
C     THE DRAWING COLOR WILL BE CHANGED TO ONE OF THE FOLLOWING:
C     BLACK, LIGHT RED, LIGHT YELLOW,LIGHT GREEN, LIGHT CYAN, LIGHT BLUE,
C     LIGHT MAGENTA WHITE, DARK RED, DARK YELLOW,DARK GREEN, DARK CYAN,
C     DARK BLUE, DARK MAGENTA, PALE GREY, DARK GREY .
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER INT
C
C     + + + ARGUMENT SPECFICATION + + +
C     INT - INTEGER VALUE REPRESENTING A COLOR (IN)
C
C     + + + LOCAL VARIBLES + + +
      INTEGER colorarray(0:15), i
C
C     + + + EXTERNALS + + +
      EXTERNAL IGRCOLOURN
C
C     + + + INTRINICS+ + +
      INTRINSIC MOD
C
C     + + + DATA + + +
      DATA (colorarray(i),i=0,15)/12, 31, 63, 95, 127, 159, 191, 207, 
     &      40, 70, 100, 140, 170, 200, 215, 223/
C
C     + + + END SPECIFICATIONS + + +
C
      CALL IGRCOLOURN(colorarray(MOD(INT,16)))
C
      RETURN
      END
C
C
C
      SUBROUTINE FACTOR(NUM)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL FACTOR. THERE IS NO EQUVALIENT
C     INTERACTER COMMAND SO A COMMON VARIBLE FACT WILL BE SET TO THE VALUE NUM.
C
C     + + + DUMMY ARGUMENTS + + +
      REAL NUM
C
C     + + + ARGUMENT SPECFICATION + + +
C     NUM - A REAL VALUE REPRESENTING A SCALING FACTOR (IN)
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'intset.cmn'
C
C     + + + END SPECIFICATIONS + + +
C
      IF (NUM.GT.0) THEN
        Fact = NUM
      ELSE
        Fact = 1.0
      ENDIF
 
      RETURN
      END
C
C
C
      SUBROUTINE ORIGIN(XPOS,YPOS,IORIG)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL ORIGIN. THIS IS DONE
C     BY CALLING THE INTERACTER COMMAND IGrUnits TO CHANGE THE UNITS
C     OF THE DRAWING AREA.  THIS MAY NOT WORK AT ALL  ASSUMES XPOS
C     AND YPOS ALWAYS POSITIVE.
C
C     + + + DUMMY ARGUMENTS + + +
      REAL XPOS, YPOS
      INTEGER IORIG
C
C     + + + ARGUMENT SPECFICATION + + +
C     XPOS,YPOS - FOR IORIG =1 THE ORIGIN IS XPOS, YPOS FROM THE LAST
C                       DEFINED ORIGIN (IN)
C                 FOR IORIG = 0 THE ORIGIN IS XPOS, YPOS FROM THE ORIGINAL
C                       ORIGIN (IN)
C                 FOR IORIG = -1  THE CURRENT POSTION OF THE ORIGIN FROM THE
C                       ORIGINAL ORIGIN (OUT)
C     IORIG - INTEGER VALUE TO DETERMINE WHAT TO DO
 
C     + + + INCLUDE FILES + + +
      INCLUDE 'interif.inc'
      INCLUDE 'intset.cmn'
C
C     + + + LOCAL VARIBLES + + +
      REAL lowerx, lowery, newupperx, newuppery, newlowerx, newlowery, 
     &     upperx, uppery
C
C     + + + EXTERNALS + + +
      REAL INFOGRAPHICS
      EXTERNAL INFOGRAPHICS, IGRUNITS
C
C     + + + INTRINSICS + + +
      INTRINSIC ABS
C
C     + + + END SPECIFICATIONS + + +
C
C---FIND GRAPHICSUNIT MAX/MIN
      lowerx = INFOGRAPHICS(GRAPHICSUNITMINX)
      lowery = INFOGRAPHICS(GRAPHICSUNITMINY)
      upperx = INFOGRAPHICS(GRAPHICSUNITMAXX)
      uppery = INFOGRAPHICS(GRAPHICSUNITMAXY)
C
      IF (IORIG.EQ.-1) THEN
        XPOS = ABS(lowerx)
        YPOS = ABS(lowery)
      ELSEIF (IORIG.EQ.0) THEN
        newlowerx = -XPOS
        newlowery = -YPOS
        newupperx = Gridx - XPOS
        newuppery = Gridy - YPOS
        CALL IGRUNITS(newlowerx,newlowery,newupperx,newuppery)
      ELSEIF (IORIG.EQ.1) THEN
        newlowerx = lowerx - XPOS
        newlowery = lowery - YPOS
        newupperx = upperx - XPOS
        newuppery = uppery - YPOS
        CALL IGRUNITS(newlowerx,newlowery,newupperx,newuppery)
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE WHERE(XPOS,YPOS,FAC)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL WHERE. THIS IS DONE BY
C     CALLING THE INTERACTER COMMAND InfoGraphics TO FIND THE X AND Y
C     LOCATIONS.  THE COMMON VARIBLE FACT WILL BE READ TO REPORT THE
C     VALUE.
C
C     + + + DUMMY ARGUMENTS + + +
      REAL XPOS, YPOS, FAC
C
C     + + + ARGUMENT SPECFICATION + + +
C     XPOS - A REAL VALUE REPRESENTING THE X POSTION OF THE PEN(out)
C     YPOS - A REAL VALUE REPRESENTING THE Y POSTION OF THE PEN(out)
C     FAC - A REAL VALUE REPRESENTING A SCALING FACTOR (out)
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'interif.inc'
      INCLUDE 'intset.cmn'
C
C     + + + LOCAL VARIBLES + + +
      REAL xtemp, ytemp
C
C     + + + EXTERNALS + + +
      REAL INFOGRAPHICS
      EXTERNAL INFOGRAPHICS
C
C
C     + + + END SPECIFICATIONS + + +
C
      xtemp = 0
      ytemp = 0
      xtemp = INFOGRAPHICS(GRAPHICSX)/Fact
      ytemp = INFOGRAPHICS(GRAPHICSY)/Fact
      FAC = Fact
      XPOS = xtemp
      YPOS = ytemp
      RETURN
      END
C
C
C
      SUBROUTINE DASHDF(D1,D2,D3,D4)
C
C     + + + PURPOSE + + +
C     This subroutine fills the position of the calcomp dashdf.  This will do
C     do nothing.  THE COMMAND IS NOT SUPPORTED IN INTERACTER
C
C     + + + DUMMY ARGUMENTS + + +
      REAL D1, D2, D3, D4
C
C     + + + END SPECIFICATIONS + + +
C
C     DO NOTHING
C
      RETURN
      END
C
C     Last change:  LMT   2 Jul 96    2:27 pm
C
      SUBROUTINE NXTPLT()
C
C     + + + PURPOSE + + +
C     Beeps to signal the end of screen plotting, and then waits for a
C     carriage return from the user to continue.  Finally, this routine
C     clears the screen.
C
C     + + + INTRINSICS + + +
      INTRINSIC CHAR
C
C     + + + EXTERNALS + + +
      EXTERNAL PLOT, FACTOR, NEWPEN, IOUTSTRINGXY
C
C     + + + END SPECIFICATIONS + + +
C
C---- Beep
      WRITE (*,*) CHAR(7)
      CALL NEWPEN(5)
      CALL IOUTMESSAGE('PRESS ENTER TO CONTINUE')
      CALL PLOT(0.0,0.0,-999)
      CALL FACTOR(1.0)
C
      RETURN
      END
C
C
C
      SUBROUTINE SYMBOL(X1,Y1,HEIGHT,STRING,ANGLE,NCHAR)
C
C     + + + PURPOSE + + +
C     Plots annotation and special symbols.
C     Called by the main program and routines AXIS, NUMBER, and LINE.
C     There are three calls to subroutine SYMBOL:
C     (1) The call to draw text such as titles and legends.
C     (2) The call to draw a single character referenced by its integer
C         index.
C     (3) The call to draw a plot, with a marker centered at X,Y.
C
C     + + + HISTORY + + +
C     Last change:  LMT  23 Jul 96    1:18 pm
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER NCHAR
      REAL X1, Y1, HEIGHT, ANGLE
      CHARACTER*(*) STRING
C
C     + + +INPUT ARGUMENT DEFINITIONS + + +
C     X1,Y1    - If NCHAR > 0, these are the coordinates in inches of the
C                              lower left hand corner (before rotation) of
C                              the first character being plotted for the GMARK
C                                font option, otherwise it is the left center
C                              of the first character.
C              - If NCHAR <= 0, these are the coordinates of the geometric
C                               center of the marker being plotted.
C                To continue annotation from the current X and/or Y position,
C                the corresponding X1 and/or Y1 coordinates should equal 999.
C     HEIGHT   - The height in inches of the character(s) being plotted.
C                The width of the character, including spacing, is normally
C                the same as the height.
C     STRING   - If NCHAR > 0, this contains a string array of NCHAR
C                              character(s) being plotted.
C                If NCHAR <= 0, the integer index of the marker to be plotted
C                               is contained in STRING.
C     ANGLE    - The angle, in degrees from the x-axis, at which the
C                character(s) are to be plotted.  At ANGLE=0.0, the
C                character(s) will be plotted right side up and parallel
C                to the x-axis.
C     NCHAR    - If > 0,   NCHAR is the number of charcaters in STRING to be
C                          plotted, including any trailing blanks.
C                If = 0/-1,A marker with integer index contained in
C                          STRING is centered at X1,Y1.
C                If < -1,  A marker is produced, where the move to X1,Y1
C                          is made with the line status the same as if
C                          the absolute value of NCHAR were the IPEN
C                          argument of subroutine PLOT.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER ipen, intgr, nc
      REAL xpos, ypos, x, y, hgt, f, px, py, xm, ym, s, c, ra
      CHARACTER*1 sym
C
C       + + + INCLUDE FILES+ + +
      INCLUDE 'intset.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL PLOT, PLOTSYM, WHERE, IGRCHARROTATE, IGRCHARSIZE, 
     &         IGRCHARJUSTIFY, GMARK1, IGRCHAROUT, GMKSTR
C
C     + + + INTRINSICS + + +
      INTRINSIC IABS, ICHAR, COS, SIN
C
C     + + + END SPECIFICATIONS + + +
C
C---X,Y is the final location OF TEXT UNFACTOERED:
      px = X1
      py = Y1
      hgt = HEIGHT
      ra = 0.174533*ANGLE
      c = COS(ra)
      s = SIN(ra)
      xm = hgt*0.5
      ym = xm*s
      xm = xm*c
C
      xpos = 0
      ypos = 0
      IF (px.GT.998.9) THEN
        CALL WHERE(xpos,ypos,f)
        px = xpos
      ENDIF
C
      IF (py.GT.998.9) THEN
        CALL WHERE(xpos,ypos,f)
        py = ypos
      ENDIF
C
C---Determine whether or not a line is to be drawn
      IF (NCHAR.GT.-2) THEN
        ipen = 3
      ELSE
        ipen = IABS(NCHAR)
      ENDIF
      nc = NCHAR
C
C---Move to character location unFACTORED LOCATION factored in plot
      CALL PLOT(px,py,ipen)
C
C---X,Y is the final location OF TEXT FACTORED NOT NEEDED FOR PLOT:
      x = px*Fact
      y = py*Fact
C
C---Rotate text if interacter
      IF (Symtype) THEN
C       CALL IGRCHARJUSTIFY('Left')
        CALL IGRCHARROTATE(ANGLE)
C
C---Change text size
C---not quite sure how to do that yet command is IGrCharSize(xrel,yrel)
        IF (hgt.LT.0.07) THEN
          CALL IGRCHARSIZE(hgt*4.0,hgt*4.0*5.0/6.0)
C       ELSEIF (hgt.LT.0.12) THEN
C         CALL IGRCHARSIZE(hgt*4.0,hgt*4.0*5.0/6.0)
        ELSEIF (hgt.LT.0.145) THEN
          CALL IGRCHARSIZE(hgt*4.5,hgt*4.5*5.0/6.0)
        ELSEIF (hgt.LT.0.17) THEN
          CALL IGRCHARSIZE(hgt*5.0,hgt*5.0*5.0/6.0)
C       ELSEIF (hgt.LT.0.22) THEN
C         CALL IGRCHARSIZE(hgt*4.5,hgt*4.5*5.0/6.0)
        ELSEIF (hgt.LT.0.3) THEN
          CALL IGRCHARSIZE(hgt*4.5,hgt*4.5*5.0/6.0)
        ELSEIF (hgt.LT.0.4) THEN
          CALL IGRCHARSIZE(hgt*4.0,hgt*4.0*5.0/6.0)
        ELSEIF (hgt.GT.0.5) THEN
          CALL IGRCHARSIZE(1.,1.)
        ENDIF
C       CALL IGRCHARSIZE(hgt*5.0,hgt*5.0*5.0/6.0)
      ENDIF
C
C---Plot text string:
      IF (nc.EQ.0) THEN
C
C---A single right-justified character produced (NCHAR is 0).
C---A single center-justified character produced (NCHAR is -1)
C---This character may be passed from the calling routine as a single
C---character in quotes, or as the "char", the ASCII integer index of
C---the character; for example, char(65) is the same as 'A'.:
C
        sym = STRING(1:1)
        IF (Symtype) THEN
          CALL IGRCHARJUSTIFY('Center')
          CALL PLOTSYM(ICHAR(sym),x,y)
        ELSE
          CALL GMARK1(ICHAR(sym),hgt,px-xm,py-ym)
        ENDIF
C
C---NCHAR is greater than 0 -- use standard characters stored in STRING:
      ELSEIF (nc.GT.0) THEN
        IF (Symtype) THEN
          CALL IGRCHARJUSTIFY('Left')
          IF (ANGLE.GT.0.0) THEN
            CALL IGRCHAROUT(x+xm*0.88,y,STRING)
          ELSE
            CALL IGRCHAROUT(x,y+xm*0.88,STRING)
          ENDIF
        ELSE
          CALL GMKSTR(STRING,nc,hgt,px,py,ANGLE)
        ENDIF
      ELSE
C
C---Special call to SYMBOL for a centered symbol (NCHAR is less than -1):
C---The calling routine should pass the index of the symbol desired
C---through STRING as the "char" of the symbol index number desired.
C---For example, for symbol number 1 (a dot), pass char(1);
C---this is then converted back to the integer 0 here using "ichar".
        intgr = ICHAR(STRING)
        IF (Symtype) THEN
          CALL IGRCHARJUSTIFY('Center')
          CALL PLOTSYM(intgr,x,y)
        ELSE
          CALL GMARK1(intgr,hgt,px,py)
        ENDIF
      ENDIF
C
      RETURN
      END
C
C     Last change:  LMT   6 Aug 96    2:04 pm
C
      SUBROUTINE PLOT(XPOS,YPOS,IC)
C
C     + + +PURPOSE+ + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL PLOT. THIS IS DONE BY
C     CALLING THE INTERACTER COMMANDS IGRLINETO, IGRLINETOREL, IGRMOVETO,
C     IGRMOVETOREL AND IGRAREACLEAR.  THE SUBROUTINE ORIGIN WILL BE USED TO
C     MOVE THE ORIGIN FOR ALL NEGITIVE IC VALUES. THE COMMON VARIBLE FACT
C     WILL BE USED TO SCALE THE PLOT VALUES. IC VALUES OF 2 GETS A SOLID
C     LINE, 3 MOVES THE PEN, -2 SOLID LINE ORIGIN RESET TO XPOS, YPOS,
C     -3 MOVES THE PEN AND ORIGIN RESET TO XPOS, YPOS, -999 CLEARS THE
C     SCREEN, 999 QUITS GRAPHICS MODES, AND 4 THROUGH 9 OBTAIN DIFFERENT
C     LINE TYPES.
C
C     + + +DUMMY ARGUMENTS+ + +
      REAL XPOS, YPOS
      INTEGER IC
C
C     + + + ARGUMENT SPECFICATION + + +
C     XPOS, YPOS - A REAL VALUE REPRESENTING THE X AND Y COORDINATES (IN)
C     IC - AN INTEGER VALUE SELECTING TYPE OF PLOT (IN)
C
C     + + + LOCAL VARIBLES+ + +
      CHARACTER*12 filename
      INTEGER ltype, error
      REAL xp, yp
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'interif.inc'
      INCLUDE 'print.cmn'
      INCLUDE 'intset.cmn'
C
C     + + + EXTERNALS + + +
      INTEGER INFOERROR, INFOGRSCREEN
      EXTERNAL ORIGIN, IGRLINETO, IGRMOVETO, IGRLINETYPE, INFOERROR, 
     &         INFOGRSCREEN, IGRPAUSE, IGRAREACLEAR, IGRHARDCOPY, 
     &         INTFNAME, IOUTMESSAGE, IGRQUIT, ISCREENQUIT
C
C     + + + INTRINSICS + + +
      INTRINSIC ABS
C
      SAVE error
      DATA error/0/
C
C     + + + END SPECIFICATIONS + + +
C
      xp = XPOS
      yp = YPOS
      IF (IC.EQ.2) THEN
        IF (INFOGRSCREEN(36).NE.0) CALL IGRLINETYPE(0)
        CALL IGRLINETO(xp*Fact,yp*Fact)
      ELSEIF (IC.EQ.3) THEN
        CALL IGRMOVETO(xp*Fact,yp*Fact)
      ELSEIF (IC.EQ.-3) THEN
        CALL IGRMOVETO(0.,0.)
        CALL ORIGIN(xp*Fact,yp*Fact,1)
      ELSEIF (IC.GT.3 .AND. IC.LT.10) THEN
        ltype = Linetype(IC-3)
        IF (INFOGRSCREEN(36).NE.ltype) CALL IGRLINETYPE(ltype)
        CALL IGRLINETO(xp*Fact,yp*Fact)
      ELSEIF (IC.LT.-3 .AND. IC.GT.-10) THEN
        ltype = Linetype(ABS(IC)-3)
        CALL IGRLINETYPE(ltype)
        CALL IGRLINETO(xp*Fact,yp*Fact)
        CALL ORIGIN(xp*Fact,yp*Fact,1)
      ELSEIF (IC.EQ.-999) THEN
        CALL IGRPAUSE(' ')
        CALL IGRAREACLEAR
C---CLEAR ERRORS
        error = INFOERROR(LASTERROR)
C---close print file and open new one
        IF (Alphanum.NE.0) THEN
          CALL IGRHARDCOPY('S')
          IF (INFOERROR(LASTERROR).EQ.3) GOTO 10
          CALL INTFNAME(filename)
          CALL IGRHARDCOPY(filename)
          IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &        THEN
            CALL IOUTMESSAGE('Could not open/write to printfile')
            WRITE (Errunit,*) 'Could not open/write to printfile'
            GOTO 20
          ENDIF
        ENDIF
        CALL ORIGIN(0.,0.,0)
      ELSEIF (IC.EQ.999) THEN
C---CLEAR ERRORS
        error = INFOERROR(LASTERROR)
        CALL IOUTMESSAGE('PRESS ENTER TO EXIT GRAPHICS')
        CALL IGRPAUSE(' ')
        CALL IGRQUIT
        IF (INFOERROR(LASTERROR).EQ.3) GOTO 10
        CALL ISCREENQUIT('Clear')
        CLOSE (Errunit)
      ENDIF
      GOTO 20
C
   10 CALL IOUTMESSAGE('Could not close printfile')
      WRITE (Errunit,*) 'Could not close printfile'
   20 RETURN
      END
C
C
C
      SUBROUTINE FILL(NUM,XARRAY,YARRAY)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE EMULATES THE LAHEY FORTRAN CALL FILL. THIS IS DONE BY
C     CALLING THE INTERACTER COMMANDS IGRFILLPATTERN AND IGRPOLYGONCOMPLEX.
C     THIS ROUTINE DRAWS AND FILLS POLYGON SHAPES DEFINED IN THE TWO ARRAYS.
C
C      + + + DUMMY ARGUMENTS + + +
      INTEGER NUM
      REAL XARRAY(NUM), YARRAY(NUM)
C
C     + + + ARGUMENT SPECFICATION + + +
C     XARRAY, YARRAY - ARRAYS OF REAL VALUES REPRESENTING THE X AND Y
C     COORDINATES OF THE POLYGON VERTICES(IN)
C     NUM - AN INTEGER VALUE WITH THE NUMBER OF VERTICES (IN)
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'intergs.inc'
      INCLUDE 'intset.cmn'
C
C     + + + LOCAL VARIBLES + + +
      REAL tempx(300), tempy(300)
      INTEGER i
C
C     + + + EXTERNALS + + +
      EXTERNAL IGRFILLPATTERN, IGRPOLYGONCOMPLEX
C
C     + + + END SPECIFICATIONS + + +
C
      IF (NUM.GT.300) STOP 'exceeded dimension in routine FILL'
      DO 10 i = 1, NUM
        tempx(i) = XARRAY(i)*Fact
        tempy(i) = YARRAY(i)*Fact
   10 CONTINUE
C
      CALL IGRFILLPATTERN(SOLID,MEDIUM,FILLHORIZ)
      CALL IGRPOLYGONCOMPLEX(tempx,tempy,NUM)
C
      END
C
C
C
      SUBROUTINE CIRCLE(XPOS,YPOS,RADIUS)
C
C     + + +PURPOSE+ + +
C     THIS SUBROUTINE EMULATES THE CALCOMP CALL CIRCLE. THIS IS DONE BY
C     CALLING THE INTERACTER COMMAND IGRCIRCLE.
C
C     + + +DUMMY ARGUMENTS+ + +
      REAL XPOS, YPOS, RADIUS
C
C     + + + ARGUMENT SPECFICATION + + +
C     XPOS, YPOS - A REAL VALUE REPRESENTING THE X AND Y COORDINATES OF CENTER (IN)
C     RADIUS - A REAL VALUE FOR CIRCLE RADIUS (IN)
C
C     + + + COMMON VARIBLES + + +
      INCLUDE 'intset.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL IGRCIRCLE
C
C     + + + END SPECIFICATIONS + + +
C
      CALL IGRCIRCLE(XPOS*Fact,YPOS*Fact,RADIUS)
C
      RETURN
      END
C
C
C
      SUBROUTINE PLOTSYM(CHARNUM,XPOS,YPOS)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS CALLED BY SYMBOL TO PLOT SYMBOLS AND GREEK
C     LETTERS. USES THE CHAR/ICHAR COMMANDS BUT DOES NOT USE THE ASCII
C     CHARACTER SET.  1-25 ARE THE CALCOMP/TEKTRONIX SET.  26-50 ARE
C     THE GENERAL SYMBOL SET. 51-75 ARE THE ARROWS SYMBOL SET. 76-100 ARE
C     THE COMPUTER SYMBOL SET.  THIS ONE COULD BE REPLACED WITH MORE
C     PERTINET SYMBOLS. 101-126 ARE THE MATH SYMBOL SET.  127-174 ARE THE
C     CAPITAL GREEK CHARACTERS. 175-199 ARE THE LOWER CASE GREEK LETTERS.
C
C     + + + DUMMY ARGUMENTS + + +
      REAL XPOS, YPOS
      INTEGER CHARNUM
C
C     + + + ARGUMENT SPECFICATION + + +
C     XPOS, YPOS - A REAL VALUE REPRESENTING THE X AND Y COORDINATES (IN)
C     CHARNUM - AN INTEGER VALUE BETWEEN 0 AND 255 REFERENCING A
C               CHARACTER OR SYMBOL.(IN)
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'interif.inc'
      INCLUDE 'intset.cmn'
C
C     + + + LOCAL VARIBLES + + +
      INTEGER symb, upperoffset, loweroffset, error
      CHARACTER greekset*12
C
C     + + + EXTERNALS + + +
      INTEGER INFOERROR
      EXTERNAL INFOERROR, IGRSYMBSET, IGRSYMBOUT, IGRCHAROUT, 
     &         IOUTMESSAGE, IGRCHARSET
C
C     + + + INTRINSICS + + +
      INTRINSIC CHAR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA upperoffset/64/, loweroffset/96/
      DATA greekset/'simplexg.chr'/
C
C     + + + END SPECIFICATIONS + + +
C
      error = INFOERROR(1)
      IF (CHARNUM.LT.26) THEN
        CALL IGRSYMBSET('calctek.smb')
        error = INFOERROR(LASTERROR)
        IF (error.EQ.1 .OR. error.EQ.2) GOTO 10
        CALL IGRSYMBOUT(XPOS,YPOS,CHARNUM)
      ELSEIF (CHARNUM.LT.51) THEN
        symb = CHARNUM - 25
        CALL IGRSYMBSET('general.smb')
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 10
        CALL IGRSYMBOUT(XPOS,YPOS,symb)
      ELSEIF (CHARNUM.LT.76) THEN
        symb = CHARNUM - 50
        CALL IGRSYMBSET('maths.smb')
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 10
        CALL IGRSYMBOUT(XPOS,YPOS,symb)
      ELSEIF (CHARNUM.LT.101) THEN
        symb = CHARNUM - 75
        CALL IGRSYMBSET('computer.smb')
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 10
        CALL IGRSYMBOUT(XPOS,YPOS,symb)
      ELSEIF (CHARNUM.LT.126) THEN
        symb = CHARNUM - 100
        CALL IGRSYMBSET('arrows.smb')
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 10
        CALL IGRSYMBOUT(XPOS,YPOS,symb)
      ELSEIF (CHARNUM.LT.150) THEN
        symb = CHARNUM - 125 + upperoffset
        CALL IGRCHARSET(greekset)
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 10
        CALL IGRCHAROUT(XPOS,YPOS,CHAR(symb))
        CALL IGRCHARSET(Charset)
      ELSEIF (CHARNUM.LT.174) THEN
        symb = CHARNUM - 149 + loweroffset
        CALL IGRCHARSET(greekset)
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 10
        CALL IGRCHAROUT(XPOS,YPOS,CHAR(symb))
        CALL IGRCHARSET(Charset)
      ENDIF
      RETURN
C
   10 CALL IOUTMESSAGE('Could not open/read character or symbol set.')
      WRITE (Errunit,*) 'Could not open/read character or symbol set.'
      RETURN
      END
C
C
C
      SUBROUTINE INTERRORLOG
C
C     + + + PURPOSE + + +
C     TO INITIALIZE THE ERROR OUTPUT FILE FOR INTERACTER
C
C     + + + Include files + + +
      INCLUDE 'intset.cmn'
C
C     + + + LOCAL VARIABLES + + +
      LOGICAL fileopen
      INTEGER itime, etime, iret, year, iniunit, month, day, hour, 
     &        minute, sec
C
C     + + + EXTERNALS + + +
      EXTERNAL DTCODE, SYSDATE, SYSTIME
C
C     + + + END SPECIFICATIONS + + +
C
      DO 10 iniunit = 30, 100
        INQUIRE (iniunit,OPENED=fileopen)
        IF (.NOT.fileopen) THEN
          OPEN (iniunit,FILE='error.log',ERR=30)
          CALL SYSDATE(year,month,day)
          CALL SYSTIME(hour,minute,sec)
C---REQUIRES LIBUTL
          CALL DTCODE(year,month,day,hour,minute,itime,etime,iret)
          Errunit = iniunit
          WRITE (Errunit,*) itime
          GOTO 20
        ENDIF
   10 CONTINUE
C
   20 RETURN
   30 WRITE (*,*) 'ERROR IN OPENING ERROR.LOG FILE'
      STOP
      END
C
C
C
      SUBROUTINE INTPLOTINIT(INIUNIT)
C
C     + + + PURPOSE + + +
C     TO INITIALIZE THE PRINTER OUTPUT FOR INTERACTER
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER INIUNIT
C
C     + + + Include files + + +
      INCLUDE 'interif.inc'
      INCLUDE 'intergen.inc'
      INCLUDE 'intset.cmn'
      INCLUDE 'print.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER drivenum, opt, value, i
      CHARACTER*12 filename
C
C     + + + EXTERNALS + + +
      INTEGER INFOERROR, INFOHARDWARE
      EXTERNAL INFOERROR, INFOHARDWARE, IGRHARDCOPYSELECT, 
     &         IGRHARDCOPYOPTIONS, INTJULTIME, INTFNAME, IGRHARDCOPY, 
     &         IOUTSTRING, IOUTMESSAGE
C
C     + + + END SPECIFICATIONS + + +
C
      READ (INIUNIT,*,ERR=30) drivenum
      IF (drivenum.GT.0) THEN
        IF (INFOHARDWARE(PRINTEREXP).EQ.INTNO .AND. drivenum.EQ.4)
     &          GOTO 60
        CALL IGRHARDCOPYSELECT(1,drivenum)
        DO 10 i = 1, 10
          READ (INIUNIT,*,ERR=30,END=20) opt, value
          CALL IGRHARDCOPYOPTIONS(opt,value)
   10   CONTINUE
   20   CALL INTJULTIME(drivenum)
        CALL INTFNAME(filename)
        CALL IGRHARDCOPY(filename)
        IF (INFOERROR(LASTERROR).EQ.1 .OR. INFOERROR(LASTERROR).EQ.2)
     &      GOTO 50
      ELSE
        Alphanum = 0
C---in print.cmn to prevent printing
      ENDIF
      GOTO 70
   30 CALL IOUTSTRING(
     &   'ERROR IN READING PLOT.INI FILE. NO DIGITAL PLOTFILE CREATED.')
      WRITE (Errunit,*) 
     &    'ERROR IN READING PLOT.INI FILE. NO DIGITAL PLOTFILE CREATED.'
      GOTO 70
   50 CALL IOUTMESSAGE('ERROR IN OPENING PLOTFILE.')
      WRITE (Errunit,*) 'ERROR IN OPENING PLOTFILE.'
      GOTO 70
   60 CALL IOUTMESSAGE('Error printer not selected. Run intialization')
      WRITE (Errunit,*) 'Error printer not selected. Run intialization'
   70 RETURN
C
      END
C
C
C
      SUBROUTINE INTFNAME(TEMP)
C
C     + + + PURPOSE + + +
C     TO SOLVE FOR THE CURRENT PRINTER FILE NAME.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) TEMP
C
C     + + +INPUT ARGUMENT DEFINITIONS + + +
C     TEMP - VARIBLE TO HOLD FINISHED PLOT FILE NAME
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER*12 file, fileleft, fileright
      CHARACTER*11 short*11, charlist*50
C
C     + + + EXTERNALS + + +
      INTEGER LENCHR
      EXTERNAL LENCHR, STRLFT, STRRHT, INTINCBASE
C
C       + + + INCLUDE FILES + + +
      INCLUDE 'print.cmn'
C
      DATA charlist/'Abcdefghijklmnopqrstuvwxyz0123456789_^&$#@!%(){}-~'
     &     /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (Alphanum.GT.50) THEN
        Betanum = Betanum + 1
        Alphanum = 1
        CALL INTINCBASE
      ENDIF
      file = Filebase
      fileright = file
      CALL STRRHT(fileright)
      fileright(12-LENCHR(file):12-LENCHR(file))
     &  = charlist(Alphanum:Alphanum)
      Alphanum = Alphanum + 1
      IF (LENCHR(file).LT.11) THEN
        fileleft = fileright
        CALL STRLFT(fileleft)
        short = fileleft(1:11)
        TEMP = short
      ELSE
        TEMP = fileright
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE INTINCBASE
C
C     + + + PURPOSE + + +
C     TO FIGURE THE PROPER COUNTER CHARACTER.
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER*11 base
      CHARACTER*50 charlist
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'print.cmn'
      INCLUDE 'intset.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL IOUTMESSAGE
C
C     + + + DATA INITIALIZATIONS + + +
      DATA charlist/'Abcdefghijklmnopqrstuvwxyz0123456789_^&$#@!%(){}-~'
     &     /
C
C     + + + END SPECIFICATIONS + + +
C
      base = Filebase
      IF (Betanum.GT.50) THEN
        Betanum = 1
        Alphanum = 1
        CALL IOUTMESSAGE(
     &  'Error exceeded number of plotfiles allowed. Overwriting files.'
     &  )
        WRITE (Errunit,*) 
     &     'Error exceeded number of plotfiles allowed.  writing files.'
      ENDIF
      base(1:1) = charlist(Betanum:Betanum)
      Filebase = base
C
      RETURN
      END
C
C
C
      FUNCTION INTBASENAME(BASE,DRIVENUM)
C     + + + PURPOSE + + +
C     TO SOLVE FOR THE BASEFILE NAME OF THE PRINTER FILES.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER DRIVENUM
      CHARACTER BASE*7, INTBASENAME*11
C
C     + + +INPUT ARGUMENT DEFINITIONS + + +
C     BASE-THE BASENAME OF THE PRINTER FILES FROM THE USER 6 CHARACTERS
C     DRIVENUM- THE INTEGER INDICATING WHICH DRIVER IS TO BE USED.  THIS
C     SELECTS THE 3 CHAR EXTENTION TO ADD TO THE BASE NAME.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER length, info
      CHARACTER suffix*4, basel*11
C
C     + + + EXTERNALS + + +
      INTEGER LENCHR, INFOGRHARDCOPY
      EXTERNAL STRLFT, LENCHR, INFOGRHARDCOPY
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'intergen.inc'
C
C     + + + END SPECIFICATIONS + + +
C
      IF (DRIVENUM.EQ.9) THEN
        suffix = '.cgm'
      ELSEIF (DRIVENUM.EQ.8) THEN
        suffix = '.dxf'
      ELSEIF (DRIVENUM.EQ.7) THEN
        suffix = '.pic'
      ELSEIF (DRIVENUM.EQ.6) THEN
        info = INFOGRHARDCOPY(126)
        IF (info.EQ.0) THEN
          suffix = '.pcx'
        ELSE
          suffix = '.bmp'
        ENDIF
      ELSEIF (DRIVENUM.EQ.5) THEN
        suffix = '.tek'
      ELSEIF (DRIVENUM.EQ.4) THEN
        suffix = '.prn'
      ELSEIF (DRIVENUM.EQ.3) THEN
        suffix = '.AcD'
      ELSEIF (DRIVENUM.EQ.2) THEN
        info = INFOGRHARDCOPY(122)
        IF (info.EQ.INTYES) THEN
          suffix = '.eps'
        ELSE
          suffix = '.ps'
        ENDIF
      ELSE
        suffix = '.plt'
      ENDIF
      basel = BASE
      CALL STRLFT(basel)
      length = LENCHR(basel)
      INTBASENAME = basel(1:length)//suffix
C
      RETURN
      END
C
C
C
      SUBROUTINE INTJULTIME(DRIVENUM)
C
C     + + + PURPOSE + + +
C     TO SOLVE FOR THE BASE NAME OF THE PRINTER FILES USING THE SYSTEM TIME.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER DRIVENUM
C
C     + + +INPUT ARGUMENT DEFINITIONS + + +
C     NAME-THE BASE OF THE PRINTER FILES FROM THE SYSTEM TIME 8 CHARACTERS(OUT)
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER base*8, string*9
      CHARACTER*11 INTBASENAME
      INTEGER itime, etime, iret, year, month, day, hour, minute, sec
C
C     + + + INTRINSICS + + +
CF90  INTRINSIC DATE_AND_TIME
C
C     + + + EXTERNALS + + +
      EXTERNAL DTCODE, SYSDATE, SYSTIME
C
C     + + + INCLUDE FILES + + +
      INCLUDE 'print.cmn'
C
      DATA itime/0/, etime/0/, iret/0/
C
C     + + + END SPECIFICATIONS + + +
C
      Alphanum = 1
      Betanum = 0
      Filebase = '           '
C
      CALL SYSDATE(year,month,day)
      CALL SYSTIME(hour,minute,sec)
      CALL DTCODE(year,month,day,hour,minute,itime,etime,iret)
      WRITE (string,'(I9)') itime
      base = string(3:9)
      Filebase = INTBASENAME(base,DRIVENUM)
      RETURN
      END
