C     Last change:  LMT  23 Jul 96    1:30 pm
C
      SUBROUTINE PLTFILE
C
C     + + + PURPOSE + + +
C     CREATE PLOT.INI FILE FOR INTERACTER ROUTINES.
C
C     + + + LOCAL VARIBLES + + +
      INTEGER inum, i, iniunit
      CHARACTER*54 msg
      LOGICAL fileold, fileopen
C
C     + + + VARIBLES TO BE PASSED + + +
      INTEGER option(20), optvalue(20), driver, numopt, screen, ichrtyp
      INTEGER linetype(6)
      REAL gridx, gridy
      CHARACTER*12 charset
      LOGICAL symbtype
C
C     + + + END SPECIFICATIONS + + +
C
C---Find an unopened file unit:
      DO 50 iniunit = 30, 100
        INQUIRE (iniunit,OPENED=fileopen)
        IF (.NOT.fileopen) THEN
C
C---SET INITIAL VALUES
          symbtype = .FALSE.
          charset = '            '
          ichrtyp = 1
          screen = 4
          gridx = 12.0
          gridy = 9.0
          DO 20 i = 1, 6
            linetype(i) = i - 1
   20     CONTINUE
          driver = 0
          DO 10 i = 1, 20
            option(i) = 0
            optvalue(i) = 1
   10     CONTINUE
          numopt = 1
C
C---READ IN OLD FILE IF IT EXISTS
          INQUIRE (FILE='plot.ini',EXIST=fileold)
C
C---OPEN EXISTING CONFIGURATION FILE PLOT.INI
          IF (fileold) THEN
            OPEN (iniunit,FILE='plot.ini',STATUS='OLD',ERR=70)
            READ (iniunit,9005,END=40,ERR=70) symbtype, charset, ichrtyp
            READ (iniunit,9010,END=40,ERR=70) screen, gridx, gridy
            READ (iniunit,9015,END=40,ERR=70) linetype
            READ (iniunit,9010,END=40,ERR=70) driver
            DO 30 i = 1, 20
              numopt = i
              READ (iniunit,9015,ERR=70,END=40) option(i), optvalue(i)
   30       CONTINUE
            numopt = 21
          ELSE
            OPEN (iniunit,FILE='plot.ini',STATUS='NEW',ERR=70)
          ENDIF
   40     numopt = numopt - 1
          GOTO 60
C---AT THE BEGINING- FILEOPEN
        ENDIF
   50 CONTINUE
   60 inum = 0
      CALL MAINMENU
      msg = 'SELECTION CODE (0-6)'
      CALL GETIVL(msg,0,6,inum)
C
      IF (inum.EQ.0) GOTO 80
      IF (inum.EQ.1) THEN
        CALL GRAPHICS(screen,gridx,gridy)
      ELSEIF (inum.EQ.2) THEN
        CALL FONTS(symbtype,charset,ichrtyp)
      ELSEIF (inum.EQ.3) THEN
        CALL PLOTTYPE(driver,option,optvalue,numopt)
      ELSEIF (inum.EQ.4) THEN
        CALL SELECTLINE(linetype)
      ELSEIF (inum.EQ.5) THEN
        CALL DISPLAY(screen,gridx,gridy,symbtype,charset,numopt,driver,
     &               option,optvalue,linetype)
      ELSEIF (inum.EQ.6) THEN
        CALL GRAPHICS(screen,gridx,gridy)
        CALL FONTS(symbtype,charset,ichrtyp)
        CALL PLOTTYPE(driver,option,optvalue,numopt)
        CALL SELECTLINE(linetype)
        CALL DISPLAY(screen,gridx,gridy,symbtype,charset,numopt,driver,
     &               option,optvalue,linetype)
      ENDIF
      GOTO 60
   70 WRITE (*,*) ' ERROR IN READING plot.ini FILE'
      GOTO 60
C
C---Save current values in plot.ini
   80 IF (fileold) REWIND (iniunit)
      WRITE (iniunit,9005,ERR=100) symbtype, charset, ichrtyp
      WRITE (iniunit,9010,ERR=100) screen, gridx, gridy
      WRITE (iniunit,9015,ERR=100) linetype
      WRITE (iniunit,9010,ERR=100) driver
      DO 90 i = 1, numopt
        WRITE (iniunit,9015,ERR=100) option(i), optvalue(i)
   90 CONTINUE
      ENDFILE (iniunit)
      CLOSE (iniunit)
      RETURN
C
  100 STOP ' **ERROR** IN WRITING PLOT.INI FILE'
C
 9005 FORMAT (L2,1X,A12,I3)
 9010 FORMAT (I2,2F5.2)
 9015 FORMAT (6I6)
      END
C
C
C
      SUBROUTINE MAINMENU
C
C     + +  PURPOSE + + +
C       THIS WILL DISPLAY THE MAIN MENU.
C
C     + + + END SPECIFICATIONS + + +
C
      WRITE (*,9005)
      RETURN
 9005 FORMAT (20X,'PLOT CONFIGURATION SELECTION MENU',//,
     &        '   Code        Activity',/,5X,
     &        '0  --  Save current values and Exit (default)',/,5X,
     &        '1  --  Select Graphics Resolution',/,5X,
     &        '2  --  Select Font',/,5X,'3  --  Select Hardcopy Type ',
     &        /,5X,'4  --  Select Line Types',/,5X,
     &        '5  --  Display configuration values',/,5X,
     &        '6  --  Update all values',//,
     &        ' Enter 0, 1, 2, 3, 4, 5, or 6')
      END
C
C
C
      SUBROUTINE FONTS(SYMBTYPE,CHARSET,ICHRTYP)
C
C     + +  PURPOSE + + +
C     THIS WILL SELECT THE FONT TO BE USED FOR INTERACTER ROUTINES OR IF
C     GMARK WILL BE USED
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ICHRTYP
      CHARACTER*12 CHARSET
      LOGICAL SYMBTYPE
C
C     + + + LOCAL VARIBLES + + +
      CHARACTER*54 msg
      INTEGER inum
C
C     + + + END SPECIFICATIONS + + +
C
      WRITE (*,9005)
 
C---DEFAULT SIMPLEX ROMAN SET
      inum = ICHRTYP
      msg = 'FONT SELECTION (0-12)'
      CALL GETIVL(msg,0,12,inum)
C
      IF (inum.EQ.0) GOTO 10
      ICHRTYP = inum
      SYMBTYPE = .TRUE.
      IF (inum.EQ.1) THEN
        SYMBTYPE = .FALSE.
        CHARSET = '            '
      ELSEIF (inum.EQ.2) THEN
        CHARSET = 'standard.chr'
      ELSEIF (inum.EQ.3) THEN
        CHARSET = 'SIMPLEXR.chr'
      ELSEIF (inum.EQ.4) THEN
        CHARSET = 'DUPLEXR.chr'
      ELSEIF (inum.EQ.5) THEN
        CHARSET = 'COMPLEXR.chr'
      ELSEIF (inum.EQ.6) THEN
        CHARSET = 'TRIPLEXR.chr'
      ELSEIF (inum.EQ.7) THEN
        CHARSET = 'SIMPLEXS.chr'
      ELSEIF (inum.EQ.8) THEN
        CHARSET = 'COMPLEXS.chr'
      ELSEIF (inum.EQ.9) THEN
        CHARSET = 'COMPLEXI.chr'
      ELSEIF (inum.EQ.10) THEN
        CHARSET = 'TRIPLEXI.chr'
      ELSEIF (inum.EQ.11) THEN
        CHARSET = 'GOTHICEN.chr'
      ELSEIF (inum.EQ.12) THEN
        CHARSET = 'GOTHICIT.chr'
      ELSE
        CHARSET = 'standard.chr'
      ENDIF
   10 RETURN
C
 9005 FORMAT (20X,'FONT SELECTION MENU',//,'   Code        Font',/,5X,
     &        '0   --  EXIT',/,5X,'1   --  USE GMARK',/,5X,
     &        '2   --  STANDARD',/,5X,'3   --  SIMPLEX ROMAN',/,5X,
     &        '4   --  DUPLEX ROMAN',/,5X,'5   --  COMPLEX ROMAN',/,5X,
     &        '6   --  TRIPLEX ROMAN',/,5X,'7   --  SIMPLEX SCRIPT',/,
     &        5X,'8   --  COMPLEX SCRIPT',/,5X,'9   --  COMPLEX ITALIC',
     &        /,5X,'10  --  TRIPLEX ITALIC',/,5X,
     &        '11  --  GOTHIC ENGLISH',/,5X,'12  --  GOTHIC ITALIAN',/)
      END
C
C
C
      SUBROUTINE PLOTTYPE(DRIVER,OPTION,OPTVALUE,NUMOPT)
C
C     + +  PURPOSE + + +
C     THIS WILL SELECT THE HARDCOPY DRIVER
C
C     + + + DUMMY ARGS + + +
      INTEGER OPTION(*), OPTVALUE(*), DRIVER, NUMOPT
C
C     + + + LOCAL VARIBLES + + +
      INTEGER inum
      CHARACTER*54 msg
      LOGICAL keep
C
C     + + + END SPECIFICATIONS + + +
C
      keep = .FALSE.
      WRITE (*,9005)
C
C---SET IVAL TO 2 FOR DEFAULT POSTSCRIPT
      inum = DRIVER
      msg = 'HARDCOPY SELECTION (0-10)'
      CALL GETIVL(msg,0,10,inum)
C
      IF (inum.EQ.DRIVER) keep = .TRUE.
      DRIVER = inum
      NUMOPT = 0
      IF (inum.EQ.1) THEN
        CALL HPGLDRVR(OPTION,OPTVALUE,NUMOPT,keep)
      ELSEIF (inum.EQ.2) THEN
        CALL PSDRVR(OPTION,OPTVALUE,NUMOPT,keep)
      ELSEIF (inum.EQ.4) THEN
        CALL HPGLDRVR(OPTION,OPTVALUE,NUMOPT,keep)
      ELSEIF (inum.EQ.6) THEN
        CALL PCXBMP(OPTION,OPTVALUE,NUMOPT,keep)
      ENDIF
      RETURN
C
 9005 FORMAT (20X,'PLOT FILE TYPE SELECTION MENU',//,
     &        '   Code        Plot Type',/,5X,'0  --  EXIT',/,5X,
     &        '1  --  HP-GL PLOTTER FILE',/,5X,
     &        '2  --  POSTSCRIPT/EPS FILE ',/,5X,'3  --  ACORN DRAW ',/,
     &        5X,'4  --  RASTER PRINTER FILE (HP/EPSON PRINTERS) ',/,5X,
     &        '5  --  TEKTRONIX 4014 (DEC LN03+) FILE',/,5X,
     &        '6  --  PCX/BMP FILE ',/,5X,'7  --  LOTUS PIC FILE ',/,5X,
     &        '8  --  AutoCAD DXF FILE ',/,5X,'9  --  CGM FILE',/,
     &        '    10  --  NO PLOT FILE - SCREEN ONLY',/)
      END
C
C
C
      SUBROUTINE SELECTLINE(LINETYPE)
C
C     + + +  PURPOSE + + +
C     THIS WILL SELECT THE LINETYPES TO MATCH TO CURVES
C
C     + + + DUMMY ARGS + + +
      INTEGER LINETYPE(*)
C
C     + + + LOCAL VARIBLES + + +
      CHARACTER*54 msg
      INTEGER iopt, i
C
C     + + + END SPECIFICATIONS + + +
C
C---User indicates desired line styles:
      WRITE (*,9005)
      WRITE (*,9010)
C
      iopt = 0
      WRITE (*,9015)
   10 IF (iopt.EQ.0) THEN
        WRITE (*,9020) (i,LINETYPE(i),i=1,6)
      ELSEIF (iopt.EQ.8) THEN
        WRITE (*,9010)
      ELSE
        WRITE (msg,'(A,I3)') 'LINE TYPE NUMBER FOR LINE:', iopt
        CALL GETIVL(msg,0,6,LINETYPE(iopt))
      ENDIF
      WRITE (*,9025)
      iopt = 9
      msg = 'SELECTION CODE (0-9)'
      CALL GETIVL(msg,0,9,iopt)
      IF (iopt.NE.9) GOTO 10
      RETURN
 9005 FORMAT (/,
     &' Line types/styles are selected by number.  You may specify the l
     &ine type',/,
     &' associated with each curve.  (Note, these choices have no effect
     & if the',/,
     &' application program generates its own line types internally.)',
     &/)
 9010 FORMAT (' The following are the valid INTERACTER line types:',/7X,
     &        '0  --  Solid',10X,'4  --  Dot-Dot-Dash',/,7X,
     &        '1  --  Dots',11X,'5  --  Long-Short Dashes',/,7X,
     &        '2  --  Dashed',9X,'6  --  Short Dashes',/,
     &        7X'3  --  Dot-Dash',/)
 9015 FORMAT (
     &' The following table shows the current association between line n
     &umber and type.')
 9020 FORMAT (5X,'Line    Type',/,9(I8,'  --',I3,/))
 9025 FORMAT (
     &' Enter 0 to display the line/type table, 1-6 to change a line typ
     &e,',/,
     &' 8 to display valid line types, or 9 when finished with lines.')
      END
C
C
C
      SUBROUTINE GRAPHICS(SCREEN,GRIDX,GRIDY)
C
C     + + +  PURPOSE + + +
C     THIS WILL SELECT THE SCREEN RESOLUTION AND SET THE GRID SIZE
C
C     + + + DUMMY ARGS + + +
      INTEGER SCREEN
      REAL GRIDX, GRIDY
C
C     + + + LOCAL VARIBLES + + +
      INTEGER inum
      CHARACTER*54 msg
C
C     + + + END SPECIFICATIONS + + +
C
      WRITE (*,9005)
C
C---SET IVAL TO 2 FOR DEFAULT 640X480X8
      inum = SCREEN
      msg = 'SCREEN SELECTION (0-4)'
      CALL GETIVL(msg,0,4,inum)
C
      IF (inum.EQ.0) GOTO 10
      SCREEN = inum
      GRIDY = 9.0
      GRIDX = 12.0
      IF (inum.EQ.1) THEN
        GRIDX = 12.8
        GRIDY = 9.6
      ELSEIF (inum.EQ.2) THEN
        GRIDX = 12.8
        GRIDY = 9.6
      ENDIF
   10 RETURN
C
 9005 FORMAT (20X,'SREEN RESOLUTION SELECTION MENU',//,
     &        '   Code        Screen Type',/,5X,'0  --  EXIT',/,5X,
     &        '1  --  640x480 8 color',/,5X,'2  --  640x480 16 color ',
     &        /,5X,'3  --  800x600 8 color ',/,5X,
     &        '4  --  800x600 16 color'/)
      END
C
C
C
      SUBROUTINE DISPLAY(SCREEN,GRIDX,GRIDY,SYMBTYPE,CHARSET,NUMOPT,
     &                   DRIVER,OPTION,OPTVALUE,LINETYPE)
C
C
C     + + + PURPOSE + + +
C     DISPLAY ALL THE OPTIONS
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER OPTION(*), OPTVALUE(*), DRIVER, NUMOPT, SCREEN
      INTEGER LINETYPE(6)
      REAL GRIDX, GRIDY
      CHARACTER*12 CHARSET
      LOGICAL SYMBTYPE
C
C     + + + LOCAL VARIBLES + + +
      INTEGER i, retc
C
C     + + + END SPECIFICATIONS + + +
C
      WRITE (*,9005,ERR=10) SCREEN, SYMBTYPE, CHARSET, 
     &                      (LINETYPE(i),i=1,6), DRIVER
      WRITE (*,9010,ERR=10) (OPTION(i),i=1,NUMOPT)
      WRITE (*,9015,ERR=10) (OPTVALUE(i),i=1,NUMOPT)
      CALL GETCR(retc)
      RETURN
C
   10 STOP ' **ERROR** DISPLAYING INFO'
C
 9005 FORMAT (5X,'Screen Resolution :',I4,/,
     &'   1 = 640x480x8  2 = 640x480x16   3 = 800x600x8   4 = 800x600x16
     &',/,5X,'Use INTERACTER Charcter/Symbol Sets :   ',L2,/,5X,
     &'Character Set Choosen :   ',A12,/,5X,'Line types  :   ',6I6,/,5X,
     &'Printer Driver Number :',I4,/,
     &'   0 = No Plot          1 = HP-GL       2 = PostScript      3 = A
     &corn Draw',/,
     &'   4 = Raster Hardcopy  5 = Tek4014     6 = Raster Image(PCX/BMP)
     &',/,'   7 = Lotus Pic        8 = AutoCAD DXF 9 = CGM')
 9010 FORMAT (5X,'Printer Driver Options       : ',20I4)
 9015 FORMAT (5X,'Printer Driver Option Values : ',20I4)
      END
C
C     Last change:  LMT  23 Jul 96   10:39 am
C
      SUBROUTINE PSDRVR(OPTION,OPTVALUE,NUMOPT,KEEP)
C
C     + + +  PURPOSE + + +
C     THIS WILL set the options for the postscript driver
C
C     + + + DUMMY ARGS + + +
      LOGICAL KEEP
      INTEGER OPTION(*), OPTVALUE(*), NUMOPT
C
C     + + + LOCAL VARIBLES + + +
      INTEGER ivalue, rtc, inum
      CHARACTER*54 msg, message(2)
C
C     + + + END SPECIFICATIONS + + +
C
      inum = 1
      NUMOPT = 10
      OPTION(1) = 7
      OPTION(2) = 5
      OPTION(3) = 8
      OPTION(4) = 22
      OPTION(5) = 15
      OPTION(6) = 16
      OPTION(7) = 1
      OPTION(8) = 2
      OPTION(9) = 3
      OPTION(10) = 4
C
C---INIT OPTIONS
      IF (.NOT.KEEP) THEN
C---lines b/w
        OPTVALUE(1) = 1
C---orientation
        OPTVALUE(2) = 1
C---copies
        OPTVALUE(3) = 1
C---eps
        OPTVALUE(4) = 0
C---ctrl/d
        OPTVALUE(5) = 0
C---maxstroke
        OPTVALUE(6) = 255
C---image width
        OPTVALUE(7) = 756
C---image height
        OPTVALUE(8) = 540
C---horizontal position
        OPTVALUE(9) = 20
C---vertical position
        OPTVALUE(10) = -20
      ENDIF
C
   10 WRITE (*,9010)
      WRITE (*,9005)
C
      inum = 0
      msg = 'SELECTION CODE (0-10)'
      CALL GETIVL(msg,0,10,inum)
C
      IF (inum.EQ.0) RETURN
      IF (inum.EQ.1) THEN
C---color lines
        ivalue = OPTVALUE(1)
        message(1) = ' COLOR'
        message(2) = ' BLACK & WHITE'
        CALL GET01(message,ivalue,rtc)
        IF (rtc.EQ.0) OPTVALUE(1) = ivalue
      ELSEIF (inum.EQ.2) THEN
C---orientation
        ivalue = OPTVALUE(2)
        message(1) = ' PORTRAIT'
        message(2) = ' LANDSCAPE'
        CALL GET01(message,ivalue,rtc)
        IF (rtc.EQ.0) OPTVALUE(2) = ivalue
      ELSEIF (inum.EQ.3) THEN
C---copies
        IF (OPTVALUE(3).EQ.0) OPTVALUE(3) = 1
        msg = ' NUMBER OF COPIES 1-100'
        CALL GETIVL(msg,1,100,OPTVALUE(3))
      ELSEIF (inum.EQ.4) THEN
C---eps
        ivalue = OPTVALUE(4)
        message(1) = ' POSTSCRIPT PRINTER FILE'
        message(2) = ' EPS FILE'
        CALL GET01(message,ivalue,rtc)
        IF (rtc.EQ.0) OPTVALUE(4) = ivalue
      ELSEIF (inum.EQ.5) THEN
C---ctrl/d
        ivalue = OPTVALUE(5)
        message(1) = ' REMOVE CTRL/D'
        message(2) = ' INCLUDE CRTL/D'
        CALL GET01(message,ivalue,rtc)
        IF (rtc.EQ.0) OPTVALUE(5) = ivalue
      ELSEIF (inum.EQ.6) THEN
C---max stroke
        IF (OPTVALUE(6).EQ.0) OPTVALUE(6) = 255
        msg = ' MAXIMUM STROKES PER OBJECT 10-255'
        CALL GETIVL(msg,10,255,OPTVALUE(6))
      ELSEIF (inum.EQ.7) THEN
C---
        IF (OPTVALUE(7).EQ.0) OPTVALUE(7) = 756
        msg = 'IMAGE HEIGHT IN POINTS (72ND OF AN INCH)'
C        ' MUST BE LESS THAN PAGE SIZE OF PAPER'
        CALL GETIVL(msg,100,2000,OPTVALUE(7))
      ELSEIF (inum.EQ.8) THEN
C---
        IF (OPTVALUE(8).EQ.0) OPTVALUE(8) = 540
        msg = 'IMAGE WIDTH IN POINTS (72ND OF AN INCH)'
C        ' MUST BE LESS THAN PAGE SIZE OF PAPER'
        CALL GETIVL(msg,100,2000,OPTVALUE(8))
      ELSEIF (inum.EQ.9) THEN
C---
        msg = 'HORIZONTAL IMAGE OFFSET IN POINTS'
        CALL GETIVL(msg,-1000,1000,OPTVALUE(9))
      ELSEIF (inum.EQ.10) THEN
C---
        msg = 'VERTICAL IMAGE OFFSET IN POINTS '
        CALL GETIVL(msg,-1000,1000,OPTVALUE(10))
      ENDIF
C---try again
      GOTO 10
 9005 FORMAT ('   Code        Activity',/,5X,'0  --  EXIT',/,5X,
     &        '1  --  COLOR (default B/W)',/,5X,
     &        '2  --  PORTRAIT ORIENTATION (default LANDSCAPE)',/,5X,
     &        '3  --  NUMBER OF COPIES (default 1)',/,5X,
     &        '4  --  EPS FILE (default PS)',/,5X,
     &        '5  --  REMOVE CTRL/D (default INCLUDE CRTL/D)',/,12X,
     &'REMOVE CTRL/D IF PRINTING TO A POSTSCRIPT PRINTER OVER A NETWORK'
     &,/,5X,'6  --  MAX STROKE (default 255) ',/,12X,
     &'TRY REDUCING THIS VALUE IF STACK OVERFLOW ERRORS OCCUR DURING',/,
     &12X,'PRINTING OF COMPLEX FILES ',/,5X,
     &'7  --  IMAGE HEIGHT (default 540 points)',/,5X,
     &'8  --  IMAGE WIDTH (default 756 points)',/,5X,
     &'9  --  HORIZONTAL OFFSET (default 20 points)',/,5X,
     &'10  --  VERTICAL OFFSET (default -20 points)',/)
 9010 FORMAT (20X,'POSTSCRIPT SELECTION MENU',/)
C
      END
C
C
C
      SUBROUTINE PCXBMP(OPTION,OPTVALUE,NUMOPT,KEEP)
C
C     + + +  PURPOSE + + +
C       THIS WILL set the options for the PCX/BMP driver
C
C     + + + + DUMMY ARGS + + +
      LOGICAL KEEP
      INTEGER OPTION(*), OPTVALUE(*), NUMOPT
C
C     + + + LOCAL VARIBLES + + +
      INTEGER ivalue, retc, inum
      CHARACTER*54 msg, message(3)
C
C     + + + END SPECIFICATIONS + + +
C
C
      inum = 1
      NUMOPT = 4
      OPTION(1) = 26
      OPTION(2) = 23
      OPTION(3) = 1
      OPTION(4) = 2
      IF (.NOT.KEEP) THEN
C---INIT OPTIONS
C---PCX/BMP
        OPTVALUE(1) = 0
C---COLOR PLANES
        OPTVALUE(2) = 1
C---IMAGE WIDTH
        OPTVALUE(3) = 640
C---IMAGE HEIGHT
        OPTVALUE(4) = 480
      ENDIF
C
   10 WRITE (*,9005)
      WRITE (*,9010)
C
      inum = 0
      msg = 'SELECTION CODE (0-4)'
      CALL GETIVL(msg,0,4,inum)
      IF (inum.EQ.0) RETURN
C
C---color planes
      IF (inum.EQ.1) THEN
        ivalue = 0
        message(1) = ' BLACK & WHITE'
        message(2) = ' 16 COLORS'
        message(3) = ' 256 COLORS'
        CALL GET012(message,ivalue,retc)
        IF (retc.EQ.0) THEN
          IF (ivalue.EQ.0) THEN
            OPTVALUE(2) = 1
          ELSEIF (ivalue.EQ.1) THEN
            OPTVALUE(2) = 4
          ELSEIF (ivalue.EQ.2) THEN
            OPTVALUE(2) = 8
          ENDIF
        ENDIF
C---file type
      ELSEIF (inum.EQ.2) THEN
        ivalue = OPTVALUE(1)
        message(1) = ' PCX'
        message(2) = ' BMP uncompressed'
        message(3) = ' BMP compressed'
        CALL GET012(message,ivalue,retc)
        IF (retc.EQ.0) OPTVALUE(1) = ivalue
C---image height
      ELSEIF (inum.EQ.3) THEN
        IF (OPTVALUE(3).EQ.0) OPTVALUE(3) = 640
        msg = 'IMAGE HEIGHT IN PIXELS'
        CALL GETIVL(msg,100,2000,OPTVALUE(3))
C---image width
      ELSEIF (inum.EQ.4) THEN
        IF (OPTVALUE(4).EQ.0) OPTVALUE(4) = 480
        msg = 'IMAGE WIDTH IN PIXELS'
        CALL GETIVL(msg,100,2000,OPTVALUE(4))
      ENDIF
C---TRY AGAIN
      GOTO 10
 9005 FORMAT (20X,'PCX/BMP SELECTION MENU',/)
 9010 FORMAT ('   Code        Activity',/,5X,'0  --  EXIT',/,5X,
     &        '1 --  COLOR (default B/W)',/,5X,
     &        '2  --  FILE TYPE (PCX OR BMP)',/,5X,
     &        '3  --  IMAGE HEIGHT (default 480 pixels)',/,5X,
     &        '4  --  IMAGE WIDTH (default 640 pixels)',/)
      END
C
C
C
      SUBROUTINE HPGLDRVR(OPTION,OPTVALUE,NUMOPT,KEEP)
C
C     + + +  PURPOSE + + +
C     THIS WILL set the options for the HP-GL driver
C     WAIT AND SEE WHICH OPTIONS NEEDED
C
C     + + + DUMMY ARGS + + +
      LOGICAL KEEP
      INTEGER OPTION(*), OPTVALUE(*), NUMOPT
C
C     + + + LOCAL VARIBLES + + +
      INTEGER ivalue, rtc, inum
      CHARACTER*54 msg, message(2)
C
C     + + + END SPECIFICATIONS + + +
C
      inum = 1
      NUMOPT = 6
      OPTION(1) = 5
      OPTION(2) = 8
      OPTION(3) = 1
      OPTION(4) = 2
      OPTION(5) = 3
      OPTION(6) = 4
      IF (.NOT.KEEP) THEN
C---INIT OPTIONS
C---orientation
C---landscape
        OPTVALUE(1) = 1
C---copies
C---1 copy
        OPTVALUE(2) = 1
C---image width
        OPTVALUE(3) = 756
C---image height
        OPTVALUE(4) = 540
C---horizontal position
        OPTVALUE(5) = 0
C---vertical position
        OPTVALUE(6) = 0
      ENDIF
C
   10 WRITE (*,9010)
      WRITE (*,9005)
C
      inum = 0
      msg = 'SELECTION CODE (0-6)'
      CALL GETIVL(msg,0,6,inum)
C
      IF (inum.EQ.0) RETURN
C---orientation
      IF (inum.EQ.1) THEN
        ivalue = 0
        message(1) = ' PORTRAIT'
        message(2) = ' LANDSCAPE'
        CALL GET01(message,ivalue,rtc)
        IF (rtc.EQ.0) OPTVALUE(1) = ivalue
C---copies
      ELSEIF (inum.EQ.2) THEN
        IF (OPTVALUE(2).EQ.0) OPTVALUE(2) = 1
        msg = ' NUMBER OF COPIES 1-100'
        CALL GETIVL(message,1,100,OPTVALUE(2))
C---image width
      ELSEIF (inum.EQ.3) THEN
        IF (OPTVALUE(3).EQ.0) OPTVALUE(3) = 756
        msg = 'IMAGE WIDTH IN POINTS (72ND OF AN INCH)'
C        ' MUST BE LESS THAN PAGE SIZE OF PAPER'
        CALL GETIVL(message,100,2000,OPTVALUE(3))
C---image width
      ELSEIF (inum.EQ.4) THEN
        IF (OPTVALUE(4).EQ.0) OPTVALUE(4) = 540
        msg = 'IMAGE HEIGHT IN POINTS (72ND OF AN INCH)'
C        ' MUST BE LESS THAN PAGE SIZE OF PAPER'
        CALL GETIVL(msg,100,2000,OPTVALUE(4))
C---Horizontal image offset
      ELSEIF (inum.EQ.5) THEN
        msg = 'HORIZONTAL IMAGE OFFSET IN POINTS'
        CALL GETIVL(msg,-1000,1000,OPTVALUE(5))
C---vertical image offset
      ELSEIF (inum.EQ.6) THEN
        msg = 'VERTICAL IMAGE OFFSET IN POINTS '
        CALL GETIVL(msg,-1000,1000,OPTVALUE(6))
      ENDIF
C---try again
      GOTO 10
C
 9005 FORMAT ('   Code        Activity',/,5X,'0  --  EXIT',/,5X,
     &        '1   --  PORTRAIT ORIENTATION (default LANDSCAPE)',/,5X,
     &        '2  --  NUMBER OF COPIES (default 1)',/,5X,
     &        '3  --  IMAGE WIDTH (default 756 points)',/,5X,
     &        '4  --  IMAGE HEIGHT (default 540 points)',/,5X,
     &        '5  --  HORIZONTAL OFFSET (default 0 points)',/,5X,
     &        '6  --  VERTICAL OFFSET (default 0 points)',/)
 9010 FORMAT (20X,'HP-GL/RASTER PRINTER SELECTION MENU',/,15X,
     &        'PRINTER MUST BE SELECTED IN INTERACTER.INI FILE',/)
      END
