      SUBROUTINE GETCHR
     I                  ( MSG,
     M                    CVALUE )
C
C     + + + PURPOSE + + +
C     Prompt user for a character string, stop if retc ne 0.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG, CVALUE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string array describing value needed.
C     CVALUE - User-specified character string.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL GETSTR
C
C     + + + END SPECIFICATIONS + + +
C
      Messge(1) = MSG
      retc = 0
      CALL GETSTR(1,Messge,CVALUE,retc)
      IF (retc.NE.0) STOP
      RETURN
      END
C
      SUBROUTINE GETSTR
     I                 ( NLINES, MSG,
     M                   CVALUE,
     O                   RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for a character string.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG(*), CVALUE
      INTEGER NLINES, RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NLINES - The number of lines in prompting message.
C     MSG    - Character string array describing value needed.
C     CVALUE - User-specified character string.
C     RETC   - Return code (OUT)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + END SPECIFICATIONS + + +
C
      IF (NLINES.GT.MAXLIN) STOP 'in getstr, exceeded lines'
      Num = NLINES
      DO 10 i = 1, Num
        Messge(i) = MSG(i)
   10 CONTINUE
      Rtype = 2
      CALL FMUSER(RETC)
      IF (RETC.EQ.0) CVALUE = Answer
      RETURN
      END
C
      SUBROUTINE GETCRT
C
C     + + + PURPOSE + + +
C     Prompt user for a carriage return, STOP if retc ne 0.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + EXTERNALS + + +
      EXTERNAL GETCR
C
C     + + + END SPECIFICATIONS + + +
C
      retc = 0
      CALL GETCR(retc)
      IF (retc.NE.0) STOP
      RETURN
      END
C
      SUBROUTINE GETCR
     O                ( RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for a carriage return
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RETC   - Return code
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + END SPECIFICATIONS + + +
C
      Num = 1
      Rtype = 2
      Messge(1) = 'PRESS ENTER TO CONTINUE'
      CALL FMUSER(RETC)
      RETURN
      END
C
      SUBROUTINE GETCVL
     I                 ( MSG,
     M                   CVAL )
C
C     + + + PURPOSE + + +
C     Prompt user for a character string showing default value.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG, CVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     CVAL   - The default value on input and user-selected value on output.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + EXTERNALS + + +
      EXTERNAL GETCHV
C
      retc = 0
      CALL GETCHV(MSG,CVAL,retc)
      IF (retc.NE.0) STOP
      RETURN
      END
C
      SUBROUTINE GETCHV
     I                 ( MSG,
     M                   CVAL,
     O                   RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for a character string showing default value.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG, CVAL
      INTEGER RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     CVAL   - The default value on input and user-selected value on output.
C     RETC   - Return code
C
C     + + + LOCAL VARIABLES + + +
      INTEGER l
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + INTRINSICS + + +
      INTRINSIC LEN
C
C     + + + END SPECIFICATIONS + + +
C
      l = LEN(MSG)
      IF (l.GT.62) l = 62
      Messge(1) = 'ENTER VALUE FOR '//MSG(:l)
      l = LEN(CVAL)
      IF (l.GT.62) l = 62
      Messge(2) = 'CURRENT VALUE = "'//CVAL(1:l)//'"'
      Num = 2
      Rtype = 2
      CALL FMUSER(RETC)
      IF (RETC.EQ.0 .AND. Answer.NE.'                  ') CVAL = Answer
      RETURN
      END
C
      SUBROUTINE GETIFL
     I                 ( MSG,
     M                   FILNAM )
C
C     + + + PURPOSE + + +
C     Prompt user for an input file name, giving the user a default name
C     and showing whether a file of that name already exists, keep
C     prompting until an existing file is specified.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) FILNAM, MSG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     FILNAM - The name of the file, character string with length from
C              calling routine
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + EXTERNALS + + +
      EXTERNAL PRMPFL, CHKIFL
C
C     + + + END SPECIFICATIONS + + +
C
      retc = 0
   10 CALL PRMPFL(MSG,FILNAM,retc)
      IF (retc.NE.0) STOP
      CALL CHKIFL(FILNAM,retc)
      IF (retc.NE.0) GOTO 10
      RETURN
      END
C
      SUBROUTINE GETIVL
     I                 ( MSG, IMIN, IMAX,
     M                   IVAL )
C
C     + + + PURPOSE + + +
C     Prompt user for an integer value in a specified range.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      INTEGER IMIN, IMAX, IVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     IMIN   - The minimum value accepted.
C     IMAX   - The maximum value accepted.
C     IVAL   - The default value on input and user-selected value on output.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + EXTERNALS + + +
      EXTERNAL GETNUM
C
C     + + + END SPECIFICATIONS + + +
C
      retc = 0
      CALL GETNUM(MSG,IMIN,IMAX,IVAL,retc)
      IF (retc.NE.0) STOP
      RETURN
      END
C
      SUBROUTINE GETNUM
     I                  ( MSG, IMIN, IMAX,
     M                    IVAL,
     O                    RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for an integer value in a specified range.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      INTEGER IMIN, IMAX, IVAL, RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     IMIN   - The minimum value accepted.
C     IMAX   - The maximum value accepted.
C     IVAL   - The default value on input and user-selected value on output.
C     RETC   - Return code
C
C     + + + LOCAL VARIABLES + + +
      INTEGER l, ival1
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + INTRINSICS + + +
      INTRINSIC LEN
C
C     + + + END SPECIFICATIONS + + +
C
      ival1 = IVAL
      l = LEN(MSG)
      IF (l.GT.62) l = 62
C
      Messge(1) = 'ENTER INTEGER VALUE FOR '//MSG(:l)
      WRITE (Messge(2),'(A,I7)') 'CURRENT VALUE =', ival1
      Num = 2
      Rtype = 4
   10 CALL FMUSER(RETC)
      IF (RETC.EQ.0) THEN
        IF (Answer(:4).NE.'    ') IVAL = Inum
        IF (IVAL.LT.IMIN .OR. IVAL.GT.IMAX) THEN
          WRITE (*,9005) IVAL, IMIN, IMAX
          IVAL = ival1
          GOTO 10
        ENDIF
      ENDIF
      RETURN
 9005 FORMAT (/,' Invalid response, please try again',/,
     &        ' Value entered (',I6,') exceeds range (',I6,'-',I6,')')
      END
C
      SUBROUTINE GETOPT
     I                 ( MSG,
     O                   IVAL )
C
C     + + + PURPOSE + + +
C     Prompt user for an integer value of 0 or 1.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      INTEGER IVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     IVAL   - The default value on input and user-selected value on output.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER l, ival1, iret
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + INTRINSICS + + +
      INTRINSIC LEN
C
C     + + + END SPECIFICATIONS + + +
C
      ival1 = IVAL
      l = LEN(MSG)
      IF (l.GT.62) l = 62
C
      Messge(1) = 'ENTER VALUE FOR '//MSG(:l)
      WRITE (Messge(2),'(A,I7)') 'CURRENT VALUE =', ival1
      Num = 2
      Rtype = 4
      iret = 0
   10 CALL FMUSER(iret)
      IF (iret.NE.0) STOP
      IF (Answer(:4).NE.'    ') IVAL = Inum
      IF (IVAL.LT.0 .OR. IVAL.GT.1) THEN
        WRITE (*,9005) IVAL
        IVAL = ival1
        GOTO 10
      ENDIF
      RETURN
 9005 FORMAT (/,' **ERROR** -- invalid response (',I6,
     &        ') * Please enter a 0 or 1')
      END
C
      SUBROUTINE GETRVL
     I                 ( MSG, IEXP, RMIN, RMAX,
     M                   RVAL )
C
C     + + + PURPOSE + + +
C     Prompt user for a floating point value in a specified range.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      REAL RVAL, RMIN, RMAX
      INTEGER IEXP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     IEXP   - Number of digits to right of decimal place to display.
C     RMIN   - The minimum value accepted.
C     RMAX   - The maximum value accepted.
C     RVAL   - The default value on input and user-selected value on output.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + EXTERNALS + + +
      EXTERNAL GETRNM
C
C     + + + END SPECIFICATIONS + + +
C
      retc = 0
      CALL GETRNM(MSG,IEXP,RMIN,RMAX,RVAL,retc)
      IF (retc.NE.0) STOP
      RETURN
      END
C
      SUBROUTINE GETRNM
     I                 ( MSG, IEXP, RMIN, RMAX,
     M                   RVAL,
     O                   RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for a floating point value in a specified range.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      REAL RVAL, RMIN, RMAX
      INTEGER IEXP, RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     IEXP   - Number of digits to right of decimal place to display.
C     RMIN   - The minimum value accepted.
C     RMAX   - The maximum value accepted.
C     RVAL   - The default value on input and user-selected value on output.
C     RETC   - Return code
C
C     + + + LOCAL VARIABLES + + +
      REAL rval1
      INTEGER l, nexp
      CHARACTER*9 fmt
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + INTRINSICS + + +
      INTRINSIC LEN, IABS, MIN0
C
C     + + + END SPECIFICATIONS + + +
C
      nexp = IABS(IEXP)
      nexp = MIN0(nexp,7)
      WRITE (fmt,9005) nexp
C
      rval1 = RVAL
      l = LEN(MSG)
      IF (l.GT.62) l = 62
      Messge(1) = 'ENTER FLOATING-POINT VALUE FOR '//MSG(:l)
C
      WRITE (Messge(2),fmt) 'CURRENT VALUE = ', rval1
      Num = 2
      Rtype = 3
   10 CALL FMUSER(RETC)
      IF (RETC.EQ.0) THEN
        IF (Answer(:7).NE.'       ') RVAL = Rnum
        IF (RVAL.LT.RMIN .OR. RVAL.GT.RMAX) THEN
          WRITE (*,9010) RVAL, RMIN, RMAX
          RVAL = rval1
          GOTO 10
        ENDIF
      ENDIF
      RETURN
 9005 FORMAT ('(A,F12.',I1,')')
 9010 FORMAT (/,' Invalid response, please try again',/,
     & ' Value entered (',F12.4,') exceeds range (',F12.4,'-',F12.4,')')
      END
C
      SUBROUTINE GETYES
     I                 ( MSG,
     O                   LVALUE )
C
C     + + + PURPOSE + + +
C     Prompt user for a yes or no value, STOP if retc ne 0
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      LOGICAL LVALUE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     LVALUE - Set to true if "yes", false if "no".
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc
C
C     + + + EXTERNALS + + +
      EXTERNAL GETYNO
C
C     + + + END SPECIFICATIONS + + +
C
      CALL GETYNO(MSG,LVALUE,retc)
      IF (retc.NE.0) STOP
      RETURN
      END
C
      SUBROUTINE GETYNO
     I                 ( MSG,
     O                   LVALUE, RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for an yes or no value.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      INTEGER RETC
      LOGICAL LVALUE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     LVALUE - Set to true if "yes", false if "no".
C     RETC   - Return code
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + END SPECIFICATIONS + + +
C
      Num = 1
      Messge(1) = MSG
      Rtype = 1
      CALL FMUSER(RETC)
      IF (RETC.EQ.0) LVALUE = Yes
      RETURN
      END
C
      SUBROUTINE GET012
     I                 ( MSG,
     O                   IVALUE, RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for an integer value of 0, 1, or 2.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG(3)
      INTEGER RETC, IVALUE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string array describing value needed.
C     IVALUE - The user-specified value.
C     RETC   - Return code
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + END SPECIFICATIONS + + +
C
      Messge(1) = '   Code                Activity'
      Messge(2) = '     0  --  '//MSG(1)
      Messge(3) = '     1  --  '//MSG(2)
      Messge(4) = '     2  --  '//MSG(3)
      Rtype = 5
      Num = 5
      Messge(5) = 'Enter 0, 1, or 2'
      CALL FMUSER(RETC)
      IF (RETC.EQ.0) IVALUE = Inum
      RETURN
      END
C
      SUBROUTINE GET01
     I                ( MSG,
     O                 IVALUE, RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for an integer value of 0 or 1.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG(2)
      INTEGER RETC, IVALUE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string array describing value needed.
C     IVALUE - The user-specified value.
C     RETC   - Return code
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + END SPECIFICATIONS + + +
C
      Messge(1) = '   Code                Activity'
      Messge(2) = '     0  --  '//MSG(1)
      Messge(3) = '     1  --  '//MSG(2)
      Rtype = 6
      Num = 4
      Messge(4) = 'Enter 0 or 1'
      CALL FMUSER(RETC)
      IF (RETC.EQ.0) IVALUE = Inum
      RETURN
      END
C
      SUBROUTINE GETDNM
     I                 ( MSG, DMIN, DMAX,
     M                   DVAL,
     O                   RETC )
C
C     + + + PURPOSE + + +
C     Prompt user for a Double precision value in a specified range.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) MSG
      DOUBLE PRECISION DVAL, DMIN, DMAX
      INTEGER RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MSG    - Character string describing value needed.
C     DMIN   - The minimum value accepted.
C     DMAX   - The maximum value accepted.
C     DVAL   - The default value on input and user-selected value on output.
C     RETC   - Return code
C
C     + + + LOCAL VARIABLES + + +
      DOUBLE PRECISION dval1
      INTEGER l
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL FMUSER
C
C     + + + INTRINSICS + + +
      INTRINSIC LEN, DBLE
C
C     + + + END SPECIFICATIONS + + +
C
      dval1 = DVAL
      l = LEN(MSG)
      IF (l.GT.62) l = 62
      Messge(1) = 'ENTER FLOATING-POINT VALUE FOR '//MSG(:l)
C
      WRITE (Messge(2),'(A,D12.6)') 'CURRENT VALUE = ', dval1
      Num = 2
      Rtype = 3
   10 CALL FMUSER(RETC)
      IF (RETC.EQ.0) THEN
        IF (Answer(:7).NE.'       ') DVAL = DBLE(Rnum)
        IF (DVAL.LT.DMIN .OR. DVAL.GT.DMAX) THEN
          WRITE (*,9005) DVAL, DMIN, DMAX
          DVAL = dval1
          GOTO 10
        ENDIF
      ENDIF
      RETURN
 9005 FORMAT (/,' Invalid response, please try again',/,
     & ' Value entered (',D12.6,') exceeds range (',D12.6,'-',D12.6,')')
      END
C
      SUBROUTINE FMUSER
     O                 ( RETCOD )
C
C     + + + PURPOSE + + +
C     Read the response of the user to a prompt issued by TOUSER routine
C     from the keyboard and analyzes it (numbers are restricted to 20
C     digits).  Values passed back in common block in include file
C     codmes.cmn.  Value of RTYPE determines type of value checked for.
C     If an invalid response entered, a message is printed and the
C     original prompt is reissued.
C     RTYPE
C       1    Y, y, YES, yes, N, n, NO, or no
C               sets YES=.TRUE. for Y,y,YES, or yes
C       2    Any response (up to 80 characters)
C               value returned in Character*80 ANSWER
C       3    Real value
C               value returned in RNUM
C       4    Integer value
C               value returned in INUM
C       5    Integer value of 0, 1, or 2
C               value returned in INUM
C       6    Integer value of 0 or 1
C               value returned in INUM
C
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER RETCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RETCOD - Return code 
C              RETCOD is set depending on response.
C              -1    User entered X, x, EXIT, or exit no matter the value
C                    of RTYPE (exits to operating system--STOP's)
C               0    Valid response based on RTYPE
C               1    User entered Q, q, QUIT, or quit no matter the value
C                    of RTYPE
C               2    User entered H, h, HELP, or help no matter the value
C                    of RTYPE (not implemented)
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER ans4*4, msg*10, fmt*8, vers*64
      INTEGER i, mlen, n, nlen, init
      LOGICAL fopend
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + EXTERNALS + + +
      INTEGER LENCHR
      EXTERNAL TOUSER, LENCHR, UPCASE, OPNSCR
C
C     + + + INTRINSICS + + +
      INTRINSIC INDEX
C
C     + + + DATA + + +
      SAVE init
      DATA init/0/
C
C     + + + END SPECIFICATIONS + + +
C
      IF (init.EQ.0) THEN
        vers = '@(#) libutils - User query library'
        vers = '@(#) libutils - Contact: h2osoft@usgs.gov'
        vers = '@(#) libutils - Version: 6.0x 1997/02/05'
        vers =
     & '$Id: getsubs.f,v 6.0 1997/02/05 20:00:42 rsregan Exp rsregan $'
        INQUIRE(83,OPENED=fopend)
        IF (.NOT.fopend) CALL OPNSCR(83)
        init = 1
      ENDIF
      IF (Rtype.LT.1 .OR. Rtype.GT.6) THEN
        WRITE (*,*) '*Error in FMUSER, RTYPE invalid', Rtype
        STOP
      ENDIF
      Answer = '    '
      RETCOD = 0
C
   10 CALL TOUSER
      READ (*,9015) Answer
C
C     record response in echo file on unit 83
      nlen = LENCHR(Answer)
      IF (nlen.EQ.0) THEN
        WRITE (83,9015) Answer(:1)
      ELSE
        WRITE (83,9015) Answer(:nlen)
      ENDIF
C
      ans4 = Answer(:4)
      CALL UPCASE(ans4)
C
      IF (ans4.EQ.'Q   ' .OR. ans4.EQ.'QUIT') THEN
        WRITE (*,*) 'Quit requested'
        RETCOD = 1
        GOTO 30
      ENDIF
C
      IF (ans4.EQ.'X   ' .OR. ans4.EQ.'EXIT') THEN
        WRITE (*,*) 'eXit to operating system requested'
        RETCOD = -1
        STOP
      ENDIF
C
CC    IF ( ans4.EQ.'H' .OR. ans4.EQ.'HELP' ) THEN
CC      WRITE(*,*) 'HELP NOT IMPLEMENTED'
C TO IMPLEMENT HELP CALLING ROUTINES MUST HANDLE PRINTING HELP MESSAGE
C WHEN RETCOD IS SET TO 2.
CC      RETCOD = 2
CC      GOTO 30
CC    ENDIF
C
      IF (Rtype.EQ.1) THEN
        IF (ans4.EQ.'    ') ans4 = 'Y   '
        IF (ans4.EQ.'Y   ' .OR. ans4.EQ.'YES ') THEN
          Yes = .TRUE.
        ELSEIF (ans4.EQ.'N   ' .OR. ans4.EQ.'NO  ') THEN
          Yes = .FALSE.
        ELSE
          msg = '"Y" or "N"'
          GOTO 40
        ENDIF
C
      ELSEIF (Rtype.GT.2) THEN
        DO 20 i = 1, nlen
          IF (Answer(i:i).NE.' ') THEN
            n = INDEX(Answer(i:nlen),' ')
            IF (n.NE.0) nlen = i + n - 1
            n = INDEX(Answer(:nlen),',')
            IF (n.NE.0) nlen = n - 1
            IF (Rtype.EQ.3) THEN
              n = INDEX(Answer(:nlen),'.')
              IF (n.EQ.0) n = nlen
              WRITE (fmt,9005) '(F', nlen, '.', nlen - n, ')'
              READ (Answer,fmt,ERR=40) Rnum
C
            ELSE
C             put check to see if exceeding largest 4-byte integer
              IF (nlen.GT.10) THEN
                WRITE (*,9020)
                GOTO 10
              ENDIF
              WRITE (fmt,9005) '(I', nlen, ')'
              READ (Answer,fmt,ERR=40) Inum
              IF ((Rtype.EQ.5.AND.(Inum.LT.0.OR.Inum.GT.2)) .OR. 
     &            (Rtype.EQ.6.AND.(Inum.LT.0.OR.Inum.GT.1))) GOTO 40
            ENDIF
            GOTO 30
          ENDIF
   20   CONTINUE
        Inum = 0
        Rnum = 0.0
      ENDIF
   30 RETURN
   40 IF (Rtype.EQ.3) THEN
        msg = 'Decimal'
      ELSEIF (Rtype.EQ.4) THEN
        msg = 'Integer'
      ELSEIF (Rtype.EQ.5) THEN
        msg = '0, 1, or 2'
      ELSEIF (Rtype.EQ.6) THEN
        msg = '0 or 1'
      ENDIF
      mlen = LENCHR(msg)
      WRITE (*,9010) msg(:mlen)
      GOTO 10
 9005 FORMAT (A2,I2.2,A1,I2.2,A1)
 9010 FORMAT (/,' Invalid response, please try again',/,1X,A,
     &        ' value expected')
 9015 FORMAT (A)
 9020 FORMAT (/,' Invalid response, please try again',/,
     &    ' value exceeds number of possible digits for 4-byte integer')
      END
C
      SUBROUTINE TOUSER
C
C     + + + PURPOSE + + +
C     Send a message of 1-5 lines to the user terminal.
C     A blank line is written before each message.
C     If RTYPE=1 Then '[Y,N]?' is appended to the last lines of the message.
C     See routine FMUSER for definitions of RTYPE, NUM, and MESSGE
C     Units Used:  *
C
C     + + + INCLUDES + + +
      INCLUDE 'codmes.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, n
C
C     + + + EXTERNALS + + +
      INTEGER LENCHR
      EXTERNAL LENCHR
C
C     + + + END SPECIFICATIONS + + +
C
      WRITE (*,*)
      DO 10 i = 1, Num
        n = LENCHR(Messge(i))
        IF (i.EQ.Num .AND. Rtype.EQ.1) THEN
          IF (n.LT.1) n = 72
          IF (n.GT.72) n = 72
          WRITE (*,*) Messge(Num)(1:n), ' [Y,n]? '
        ELSE
          IF (n.LT.1) n = 79
          IF (n.GT.79) n = 79
          IF (i.EQ.Num) THEN
            WRITE (*,*) Messge(i)(1:n), ': '
          ELSE
            WRITE (*,*) Messge(i)(1:n)
          ENDIF
        ENDIF
   10 CONTINUE
      RETURN
      END
