      SUBROUTINE SYSDATE
     O                  (YR,MO,DA)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS USED ON PC'S TO REPLACE THE AMDAHL
C     SYSTEM CALLS TO JULDAT, WHICH RETRIEVE THE SYSTEM DATE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER YR, MO, DA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YR     - year
C     MO     - month
C     DA     - day
C
C     + + + LOCAL VARIABLES + + +
      INTEGER*2 iyr, imo, ida
C
C     + + + EXTERNALS + + +
      EXTERNAL  GETDAT
C     GETDAT IS A MICROSOFT V4.0 SYSTEM SUBROUTINE
C
C     + + + DATA INITIALIZATIONS + + +
C
C     + + + END SPECIFICATIONS + + +
C
      CALL GETDAT(iyr,imo,ida)
      YR = iyr - (iyr/100)*100
      MO = imo
      DA = ida
      RETURN
      END
C
C
C
      SUBROUTINE SYSTIME
     O                  ( IHR, IMN, ISEC )
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS USED TO RETRIEVE THE SYSTEM TIME.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER IHR, IMN, ISEC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IHR    - Hour since midnight
C     IMN    - Minute since hour
C     ISEC   - Second since minute
C
C     + + + LOCAL VARIABLES + + +
      INTEGER*2 ihour, imin, isecnd, i100th
C
C     + + + EXTERNALS + + +
      EXTERNAL  GETTIM
C     GETTIM IS A MICROSOFT FORTRAN VER 4.0 SYSTEM SUBROUTINE
C
C     + + + END SPECIFICATIONS + + +
C
      CALL GETTIM(ihour,imin,isecnd,i100th)
      IHR = ihour
      IMN = imin
      ISEC = isecnd
      RETURN
      END
C
C
C
      SUBROUTINE SYSSEC
     O                 ( SEC )
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS USED TO RETRIEVE THE SYSTEM TIME.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER SEC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SEC    - NUMBER OF SECONDS SINCE MIDNIGHT TIMES 100
C
C     + + + LOCAL VARIABLES + + +
      INTEGER*2 ihour, imin, isecnd, i100th
C
C     + + + EXTERNALS + + +
      EXTERNAL  GETTIM
C     GETTIM IS A MICROSOFT FORTRAN VER 4.0 SYSTEM SUBROUTINE
C
C     + + + END SPECIFICATIONS + + +
C
      CALL GETTIM(ihour,imin,isecnd,i100th)
      SEC=(ihour*3600+imin*60+isecnd)*100+i100th
      RETURN
      END
