      SUBROUTINE SYSDATE
     O                  (YR,MO,DA)
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS USED TO REPLACE THE AMDAHL
C     SYSTEM CALLS TO SYSDATE, WHICH RETRIEVE THE SYSTEM DATE.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER YR, MO, DA
C
C     + + + ARGUMENT DEFINITIONS + + +
C     YR     - year
C     MO     - month
C     DA     - day
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i
      CHARACTER datebuf*24, mon*3, month(12)*3
C
C     + + + EXTERNALS + + +
      CHARACTER*24 FDATE
      EXTERNAL  FDATE
C     FDATE IS A SILICON GRAPHICS SYSTEM SUBROUTINE
C
      DATA month/'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug',
     &           'Sep', 'Oct', 'Nov', 'Dec'/
C
C     + + + END SPECIFICATIONS + + +
C
      datebuf = FDATE()
      READ(datebuf,'(4X,A3,I3,12X,I2)') mon, DA, YR
      MO = 1
      DO 10 i = 1, 12
        IF (mon.EQ.month(i)) THEN
          MO = i
          GOTO 20
        ENDIF
   10 CONTINUE
   20 RETURN
      END
C
C
C
      SUBROUTINE SYSTIME
     O                  ( IHR, IMN, ISEC )
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS USED TO RETRIEVE THE SYSTEM TIME.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER IHR, IMN, ISEC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IHR     - Hour since midnight
C     IMN     - Minute since hour
C     ISEC    - Seconds since minute
C
C     + + + LOCAL VARIABLES + + +
      CHARACTER*24 datebuf
C
C     + + + EXTERNALS + + +
      CHARACTER*24 FDATE
      EXTERNAL  FDATE
C     FDATE IS A SILICON GRAPHICS SYSTEM SUBROUTINE
C
C     + + + END SPECIFICATIONS + + +
C
      datebuf = FDATE()
      READ(datebuf,'(10X,3(1X,I2))') IHR, IMN, ISEC
      RETURN
      END
C
C
C
      SUBROUTINE SYSSEC
     O                 ( SEC )
C
C     + + + PURPOSE + + +
C     THIS SUBROUTINE IS USED TO RETRIEVE THE SYSTEM TIME.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER SEC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     SEC    - NUMBER OF SECONDS SINCE MIDNIGHT TIMES 100
C
C     + + + LOCAL VARIABLES + + +
      INTEGER hh, mm, ss
C
C     + + + EXTERNALS + + +
      EXTERNAL  SYSTIME
C
C     + + + END SPECIFICATIONS + + +
C
      CALL SYSTIME(hh,mm,ss)
      SEC = hh*3600 + mm*60 + ss
      SEC = SEC*100
      RETURN
      END
